import java.io.*;
import java.net.*;
import java.nio.*;
import java.nio.channels.*;
import java.nio.file.*;


public class Test{

  private static void doServer(Path path) throws IOException{
    path.toFile().deleteOnExit();
    try(var server = ServerSocketChannel.open(StandardProtocolFamily.UNIX).bind(UnixDomainSocketAddress.of(path))){
      try(var sock = server.accept()){
        ByteBuffer buffer = ByteBuffer.allocate(4096);
        int len;
        while((len = sock.read(buffer)) > 0){
          buffer.flip();
          System.out.print(new String(buffer.array(), 0, len));
        }
        System.out.println();
      }
    }
  }

  private static void doClient(Path path, String message) throws IOException{
    try(var sock = SocketChannel.open(StandardProtocolFamily.UNIX)){
      sock.connect(UnixDomainSocketAddress.of(path));
      sock.write(ByteBuffer.wrap(message.getBytes()));
    }
  }

  public static void main(String[] args) throws Exception{
    String mode = args[0];
    Path path = Path.of(args[1]);

    if(mode.equals("server")){
      doServer(path);
    }
    else if(mode.equals("client")){
      doClient(path, args[2]);
    }
    else{
      throw new RuntimeException("Unknown mode");
    }
  }

}
